function varargout = rainSTORM_Image_Viewer(varargin)
% RAINSTORM_IMAGE_VIEWER MATLAB code for rainSTORM_Image_Viewer.fig
%      RAINSTORM_IMAGE_VIEWER, by itself, creates a new RAINSTORM_IMAGE_VIEWER or raises the existing
%      singleton*.
%
%      H = RAINSTORM_IMAGE_VIEWER returns the handle to a new RAINSTORM_IMAGE_VIEWER or the handle to
%      the existing singleton*.
%
%      RAINSTORM_IMAGE_VIEWER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RAINSTORM_IMAGE_VIEWER.M with the given input arguments.
%
%      RAINSTORM_IMAGE_VIEWER('Property','Value',...) creates a new RAINSTORM_IMAGE_VIEWER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before rainSTORM_Image_Viewer_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to rainSTORM_Image_Viewer_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help rainSTORM_Image_Viewer

% Last Modified by GUIDE v2.5 11-Apr-2016 15:49:17

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @rainSTORM_Image_Viewer_OpeningFcn, ...
    'gui_OutputFcn',  @rainSTORM_Image_Viewer_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before rainSTORM_Image_Viewer is made visible.
function rainSTORM_Image_Viewer_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to rainSTORM_Image_Viewer (see VARARGIN)

% Choose default command line output for rainSTORM_Image_Viewer
handles.output = hObject;
if length(varargin)>1
    set(hObject, 'Name', strcat('rainSTORM_Image_Viewer',' (', varargin{2}, ')'));
end
handles.params=varargin{1};
% disp('rainSTORM_Image_Viewer_OpeningFcn')

if ~isempty(varargin)
    params=varargin{1};
end
handles.params=params;

handles = setup_Channel_Select_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Select_Recon_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles.params=params;

if length(params.ch_data)<2
    set(handles.pushbutton_Open_Calibration_Tool,'Enable','off');
end

if length(params.ch_data)<2
    set(handles.pushbutton_Open_Merge_Tool,'Enable','off');
end

if ~(handles.params.ch_data{1, 1}.reviewer{1}.settings.flagDebug)
    set(handles.pushShowrejSupIm,'Visible','off');
else
    set(handles.pushShowrejSupIm,'Visible','on');
end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes rainSTORM_Image_Viewer wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = rainSTORM_Image_Viewer_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_Add_Recon.
function pushbutton_Add_Recon_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Add_Recon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

num_of_recons = length(handles.Recon_Select_Radiobutton_h);
selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

handles.params.ch_data{selected_channel,1}.reviewer{num_of_recons+1,1} =...
    handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1};
handles.params.ch_data{selected_channel,1}.reviewer{num_of_recons+1,1}.recon_name =...
    ['Recon ',num2str(num_of_recons+1)];

% Overwrite the default raw image size for image reconstruction with the raw stack size.
handles.params.ch_data{selected_channel,1}.reviewer{end,1}.settings.recon_algo_settings.sizeOfCCDFrame.val = ...
    handles.params.ch_data{selected_channel,1}.rawdata_mgr.myImInfo.sizeOfCCDFrame;
handles.params.ch_data{selected_channel,1}.reviewer{end,1}.settings.recon_algo_settings.pixelWidth.val = ...
    handles.params.ch_data{selected_channel,1}.rawdata_mgr.myImInfo.pixelWidth;

handles = setup_Select_Recon_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);
guidata(hObject, handles);


% --- Executes on button press in pushbutton_Remove_Recon.
function pushbutton_Remove_Recon_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Remove_Recon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

number_of_recons = length(handles.Recon_Select_Radiobutton_h);
if number_of_recons>1
    selected_channel = get_selected_channel(hObject, eventdata, handles);
    selected_recon = get_selected_Recon(hObject, eventdata, handles);
    
    handles.params.ch_data{selected_channel,1}.reviewer = ...
        handles.params.ch_data{selected_channel,1}.reviewer([1:(selected_recon-1) (selected_recon+1:end)]);
    
    handles = setup_Select_Recon_Panel(hObject, eventdata, handles);
    guidata(hObject, handles);
    
    handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
    guidata(hObject, handles);
    
    handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);
    guidata(hObject, handles);
end


% --- Executes on button press in pushbutton_Add_Filter.
function pushbutton_Add_Filter_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Add_Filter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);
selected_filter = get_selected_Filter(hObject, eventdata, handles);

handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters{end+1,1} =...
    handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters{selected_filter,1};

handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);
guidata(hObject, handles);


% --- Executes on button press in pushbutton_Remove_Filter.
function pushbutton_Remove_Filter_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Remove_Filter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

number_filters = length(handles.Filter_Select_Radiobutton_h);
if number_filters>1
    selected_channel = get_selected_channel(hObject, eventdata, handles);
    selected_recon = get_selected_Recon(hObject, eventdata, handles);
    selected_filter = get_selected_Filter(hObject, eventdata, handles);
    
    handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters = ...
        handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters([1:(selected_filter-1) (selected_filter+1:end)]);
    
    handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
    guidata(hObject, handles);
    
    handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);
    guidata(hObject, handles);
end


% --- Executes on selection change in popupmenu_Add_Filter.
function popupmenu_Add_Filter_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_Add_Filter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_Add_Filter contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_Add_Filter

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters{end+1, 1} = struct(...
    'filter_name',handles.algo_names_and_handles_loc_filters.names{get(hObject,'Value')},...
    'settings',rainSTORM_default_settings_loc_filters(handles.algo_names_and_handles_loc_filters.names{get(hObject,'Value')})...
    );

handles = setup_Select_Filter_Panel(hObject, eventdata, handles);

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function popupmenu_Add_Filter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_Add_Filter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

handles.algo_names_and_handles_loc_filters = rainSTORM_default_settings_loc_filters;
set(hObject,'String',handles.algo_names_and_handles_loc_filters.names);

guidata(hObject, handles);

% --- Executes on selection change in popupmenu_Recon_Algo_Select.
function popupmenu_Recon_Algo_Select_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_Recon_Algo_Select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_Recon_Algo_Select contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_Recon_Algo_Select

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_name = ...
    handles.algo_names_and_handles_recon.names{get(hObject,'Value')};

handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_settings = ...
    rainSTORM_default_settings_recon_algo(...
    handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_name...
    );

% Overwrite the default raw image size for image reconstruction with the raw stack size.
handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_settings.sizeOfCCDFrame.val = ...
    handles.params.ch_data{selected_channel,1}.rawdata_mgr.myImInfo.sizeOfCCDFrame;
handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_settings.pixelWidth.val = ...
    handles.params.ch_data{selected_channel,1}.rawdata_mgr.myImInfo.pixelWidth;

handles = setup_Recon_Algo_Settings_Panel(hObject, eventdata, handles);

guidata(hObject, handles);




% --- Executes during object creation, after setting all properties.
function popupmenu_Recon_Algo_Select_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_Recon_Algo_Select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% disp('popupmenu1_CreateFcn')

handles.algo_names_and_handles_recon = rainSTORM_default_settings_recon_algo;
set(hObject,'String',handles.algo_names_and_handles_recon.names);

guidata(hObject, handles);


function handles = setup_Channel_Select_Panel(hObject, eventdata, handles)

num_of_channels = length(handles.params.ch_data);
for idx_ch = 1:min(num_of_channels,7)
    panel_pos = get(handles.uipanel_Select_Channel,'Position');
    panel_unit = get(handles.uipanel_Select_Channel,'Unit');
    handles.Channel_Settings_Radiobutton_h(idx_ch) = uicontrol(...
        handles.uipanel_Select_Channel,...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Style','radiobutton',...
        'String',handles.params.ch_data{idx_ch,1}.channel_name,...['Ch ', num2str(idx_ch),': ',handles.params.ch_data{idx_ch,1}.channel_name]
        'HorizontalAlignment','left',...
        'Units',panel_unit,...
        'Position', [10 panel_pos(4)-45-(idx_ch-1)*30 panel_pos(3)-20 20]);
    
end
set(handles.uipanel_Select_Channel,...
    'SelectionChangeFcn',@SelectionChangeFcn_Channel_select);


guidata(hObject, handles);


function SelectionChangeFcn_Channel_select(hObject, eventdata)

handles = guidata(gcbo);
handles = setup_Select_Recon_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
guidata(hObject, handles);

handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);
if isfield(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings,'undrift');
    set(handles.pushbutton_Set_Anchor,'Enable','off');
else
    set(handles.pushbutton_Set_Anchor,'Enable','on');
end
guidata(hObject, handles);


function handles = setup_Select_Recon_Panel(hObject, eventdata, handles)

h = get(handles.uipanel_Select_Recon,'Children');
h(h == handles.uipanel_Select_Recon_Slider) = [];
delete(h);
handles.Recon_Select_Radiobutton_h = [];

selected_channel = get_selected_channel(hObject, eventdata, handles);

panel_pos = get(handles.uipanel_Select_Recon,'Position');
panel_unit = get(handles.uipanel_Select_Recon,'Unit');

panel_line_space = 30;
panel_first_line_pos = panel_pos(4)-panel_line_space/2;
panel_max_lines = floor(panel_pos(4) / panel_line_space)-1;

num_of_recons = length(handles.params.ch_data{selected_channel}.reviewer);
for idx_recon = 1:num_of_recons
    if idx_recon > panel_max_lines
        visibility='off';
    else
        visibility='on';
    end
    handles.Recon_Select_Radiobutton_h(idx_recon) = uicontrol(...
        handles.uipanel_Select_Recon,...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Style','radiobutton',...
        'String',handles.params.ch_data{selected_channel,1}.reviewer{idx_recon,1}.recon_name,...['Ch ', num2str(selected_channel),': ',handles.params.ch_data{selected_channel,1}.reviewer{idx_recon,1}.recon_name]
        'HorizontalAlignment','left',...
        'Units',panel_unit,...
        'Visible',visibility,...
        'Position', [10 panel_pos(4)-15-idx_recon*30 panel_pos(3)-25 20]);
end

set(handles.uipanel_Select_Recon,...
    'SelectionChangeFcn',@SelectionChangeFcn_Recon_select);

if num_of_recons<=panel_max_lines
    set(handles.uipanel_Select_Recon_Slider,...
        'Visible','off');
else
    set(handles.uipanel_Select_Recon_Slider,...
        'Visible','on',...
        'Min',0,'Max',(num_of_recons-panel_max_lines),...
        'Value',(num_of_recons-panel_max_lines),...
        'Callback',{@uipanel_Select_Recon_slider_callback,...
        handles, panel_first_line_pos, panel_max_lines, panel_line_space},...
        'SliderStep',[1 1]./(num_of_recons-panel_max_lines));
end

guidata(hObject, handles);

function SelectionChangeFcn_Recon_select(hObject, eventdata)

handles = guidata(gcbo);
handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
guidata(hObject, handles);
handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);


selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);
if isfield(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings,'undrift');
    set(handles.pushbutton_Set_Anchor,'Enable','off');
else
    set(handles.pushbutton_Set_Anchor,'Enable','on');
end
guidata(hObject, handles);

function uipanel_Select_Recon_slider_callback(hObject, eventdata, handles, panel_first_line_pos, panel_max_lines, panel_line_space)

val = get(hObject,'Value');

num_of_params = length(handles.Recon_Select_Radiobutton_h);
for idx_setting = 1:num_of_params
    %     for idx_component = 1:length(handles.Filter_Select_Radiobutton_h(idx_setting).h)
    h = handles.Recon_Select_Radiobutton_h(idx_setting);%.h(idx_component);
    pos = get(h,'Position');
    pos_new = panel_first_line_pos - idx_setting * panel_line_space + (num_of_params-panel_max_lines - val) * panel_line_space;
    pos(2) = pos_new;
    if (pos_new < panel_first_line_pos - panel_max_lines * panel_line_space) || (pos_new > panel_first_line_pos - panel_line_space)
        visibility='off';
    else
        visibility='on';
    end
    set(h,...
        'Position',pos,...
        'Visible',visibility);
    %     end
end

guidata(hObject, handles);


function handles = setup_Select_Filter_Panel(hObject, eventdata, handles)

h = get(handles.uipanel_Select_Filter,'Children');
h(h == handles.uipanel_Select_Filter_Slider) = [];
delete(h);
handles.Filter_Select_Radiobutton_h = [];

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

panel_pos = get(handles.uipanel_Select_Filter,'Position');
panel_unit = get(handles.uipanel_Select_Filter,'Unit');

panel_line_space = 30;
panel_first_line_pos = panel_pos(4)-panel_line_space/2;
panel_max_lines = floor(panel_pos(4) / panel_line_space)-1;

num_of_filters = length(handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters);
for idx_filter = 1:num_of_filters
    if idx_filter > panel_max_lines
        visibility='off';
    else
        visibility='on';
    end
    handles.Filter_Select_Radiobutton_h(idx_filter) = uicontrol(...
        handles.uipanel_Select_Filter,...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Style','radiobutton',...
        'String',handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters{idx_filter,1}.filter_name,...
        'HorizontalAlignment','left',...
        'Units',panel_unit,...
        'Visible',visibility,...
        'Position', [10 panel_pos(4)-15-idx_filter*30 panel_pos(3)-25 20]);
end

set(handles.uipanel_Select_Filter,...
    'SelectionChangeFcn',@SelectionChangeFcn_Select_Filter);

if num_of_filters<=panel_max_lines
    set(handles.uipanel_Select_Filter_Slider,...
        'Visible','off');
else
    set(handles.uipanel_Select_Filter_Slider,...
        'Visible','on',...
        'Min',0,'Max',(num_of_filters-panel_max_lines),...
        'Value',(num_of_filters-panel_max_lines),...
        'Callback',{@uipanel_Select_Filter_Slider_callback,...
        handles, panel_first_line_pos, panel_max_lines, panel_line_space},...
        'SliderStep',[1 1]./(num_of_filters-panel_max_lines));
end

% update Recon_Algo_Select
handles = setup_Recon_Algo_Settings_Panel(hObject, eventdata, handles);

guidata(hObject, handles);

function SelectionChangeFcn_Select_Filter(hObject, eventdata)

handles = guidata(gcbo);
handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);
guidata(hObject, handles);


function uipanel_Select_Filter_Slider_callback(hObject, eventdata, handles, panel_first_line_pos, panel_max_lines, panel_line_space)

val = get(hObject,'Value');

num_of_params = length(handles.Filter_Select_Radiobutton_h);
for idx_setting = 1:num_of_params
    %     for idx_component = 1:length(handles.Filter_Select_Radiobutton_h(idx_setting).h)
    h = handles.Filter_Select_Radiobutton_h(idx_setting);%.h(idx_component);
    pos = get(h,'Position');
    pos_new = panel_first_line_pos - idx_setting * panel_line_space + (num_of_params-panel_max_lines - val) * panel_line_space;
    pos(2) = pos_new;
    if (pos_new < panel_first_line_pos - panel_max_lines * panel_line_space) || (pos_new > panel_first_line_pos - panel_line_space)
        visibility='off';
    else
        visibility='on';
    end
    set(h,...
        'Position',pos,...
        'Visible',visibility);
    %     end
end

guidata(hObject, handles);


function handles = setup_Filter_Settings_Panel(hObject, eventdata, handles)

h = get(handles.uipanel_Filter_Settings,'Children');
h(h == handles.uipanel_Filter_Settings_slider) = [];
delete(h);
handles.Filter_Settings_h = [];

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);
selected_filter = get_selected_Filter(hObject, eventdata, handles);

filter_settings = handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters{selected_filter,1}.settings;

panel_pos = get(handles.uipanel_Filter_Settings,'Position');
panel_unit = get(handles.uipanel_Filter_Settings,'Unit');

panel_line_space = 30;
panel_first_line_pos = panel_pos(4)-panel_line_space/2;
panel_max_lines = floor(panel_pos(4) / panel_line_space)-1;
filter_settings_names = fieldnames(filter_settings);

num_of_params = length(filter_settings_names);

for idx_param = 1:num_of_params
    if idx_param > panel_max_lines
        visibility='off';
    else
        visibility='on';
    end
    % descriptions
    handles.Filter_Settings_h(idx_param).h(1) = uicontrol(...
        handles.uipanel_Filter_Settings,...
        'Style','text',...
        'String',filter_settings.(filter_settings_names{idx_param}).text,...
        'HorizontalAlignment','left',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'TooltipString',filter_settings.(filter_settings_names{idx_param}).tooltip,...
        'Units',panel_unit,...
        'Visible',visibility,...
        'Position', [10 panel_first_line_pos-idx_param*panel_line_space 150 20]);
    
    % input uicontrols
    if length(filter_settings.(filter_settings_names{idx_param}).val) == 1
        handles.Filter_Settings_h(idx_param).h(2) = uicontrol(...
            handles.uipanel_Filter_Settings,...
            'Callback',{@set_Filter_Settings_value, filter_settings_names(idx_param), 1, filter_settings.(filter_settings_names{idx_param}).type},...
            'Style','edit',...
            'String',num2str(filter_settings.(filter_settings_names{idx_param}).val),...
            'HorizontalAlignment','center',...
            'Units',panel_unit,...
            'Visible',visibility,...
            'Position', [220  panel_first_line_pos-idx_param*panel_line_space 50 20]);
    else
        handles.Filter_Settings_h(idx_param).h(2) = uicontrol(...
            handles.uipanel_Filter_Settings,...
            'Callback',{@set_Filter_Settings_value, filter_settings_names(idx_param), 1, filter_settings.(filter_settings_names{idx_param}).type},...
            'Style','edit',...
            'String',num2str(filter_settings.(filter_settings_names{idx_param}).val(1)),...
            'HorizontalAlignment','center',...
            'Units',panel_unit,...
            'Visible',visibility,...
            'Position', [160  panel_first_line_pos-idx_param*panel_line_space 50 20]);
        handles.Filter_Settings_h(idx_param).h(3) = uicontrol(...
            handles.uipanel_Filter_Settings,...
            'Callback',{@set_Filter_Settings_value, filter_settings_names(idx_param), 2, filter_settings.(filter_settings_names{idx_param}).type},...
            'Style','edit',...
            'String',num2str(filter_settings.(filter_settings_names{idx_param}).val(end)),...
            'HorizontalAlignment','center',...
            'Units',panel_unit,...
            'Visible',visibility,...
            'Position', [220  panel_first_line_pos-idx_param*panel_line_space 50 20]);
    end
end

if num_of_params<=panel_max_lines
    set(handles.uipanel_Filter_Settings_slider,...
        'Visible','off');
else
    set(handles.uipanel_Filter_Settings_slider,...
        'Visible','on',...
        'Min',0,'Max',(num_of_params-panel_max_lines),...
        'Value',(num_of_params-panel_max_lines),...
        'Callback',{@uipanel_Filter_Settings_slider_callback,...
        handles, panel_first_line_pos, panel_max_lines, panel_line_space},...
        'SliderStep',[1 1]./(num_of_params-panel_max_lines));
end

guidata(hObject, handles);


function uipanel_Filter_Settings_slider_callback(hObject, eventdata, handles, panel_first_line_pos, panel_max_lines, panel_line_space)

val = get(hObject,'Value');

num_of_params = length(handles.Filter_Settings_h);
for idx_setting = 1:num_of_params
    for idx_component = 1:length(handles.Filter_Settings_h(idx_setting).h)
        h = handles.Filter_Settings_h(idx_setting).h(idx_component);
        pos = get(h,'Position');
        pos_new = panel_first_line_pos - idx_setting * panel_line_space + (num_of_params-panel_max_lines - val) * panel_line_space;
        pos(2) = pos_new;
        if (pos_new < panel_first_line_pos - panel_max_lines * panel_line_space) || (pos_new > panel_first_line_pos - panel_line_space)
            visibility='off';
        else
            visibility='on';
        end
        set(h,...
            'Position',pos,...
            'Visible',visibility);
    end
end

guidata(hObject, handles);


function set_Filter_Settings_value(hObject, eventdata, param_name, idx, type)

handles = guidata(gcbo);

switch type
    case 'number'
        data_to_write = str2num(get(hObject,'String'));
    case 'text'
        data_to_write = get(hObject,'String');
    otherwise
        data_to_write = get(hObject,'String');
end

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);
selected_filter = get_selected_Filter(hObject, eventdata, handles);

handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters{selected_filter,1}.settings.(param_name{1}).val(idx)...
    = data_to_write;

guidata(hObject, handles);
setup_Filter_Settings_Panel(handles.figure1, eventdata, handles);



function handles = setup_Recon_Algo_Settings_Panel(hObject, eventdata, handles)

h = get(handles.uipanel_Recon_Algo_Settings,'Children');
h(h == handles.uipanel_Recon_Algo_Settings_slider) = [];
delete(h);
handles.Recon_Algo_Settings_h = [];

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);
selected_filter = get_selected_Filter(hObject, eventdata, handles);

filter_settings = handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_settings;

panel_pos = get(handles.uipanel_Recon_Algo_Settings,'Position');
panel_unit = get(handles.uipanel_Recon_Algo_Settings,'Unit');

panel_line_space = 30;
panel_first_line_pos = panel_pos(4)-panel_line_space/2;
panel_max_lines = floor(panel_pos(4) / panel_line_space)-1;
filter_settings_names = fieldnames(filter_settings);

num_of_params = length(filter_settings_names);

for idx_param = 1:num_of_params
    if idx_param > panel_max_lines
        visibility='off';
    else
        visibility='on';
    end
    % descriptions
    handles.Recon_Algo_Settings_h(idx_param).h(1) = uicontrol(...
        handles.uipanel_Recon_Algo_Settings,...
        'Style','text',...
        'String',filter_settings.(filter_settings_names{idx_param}).text,...
        'HorizontalAlignment','left',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'TooltipString',filter_settings.(filter_settings_names{idx_param}).tooltip,...
        'Units',panel_unit,...
        'Visible',visibility,...
        'Position', [10 panel_first_line_pos-idx_param*panel_line_space 150 20]);
    
    % input uicontrols
    if length(filter_settings.(filter_settings_names{idx_param}).val) == 1
        handles.Recon_Algo_Settings_h(idx_param).h(2) = uicontrol(...
            handles.uipanel_Recon_Algo_Settings,...
            'Callback',{@set_Recon_Algo_Settings_value, filter_settings_names(idx_param), 1, filter_settings.(filter_settings_names{idx_param}).type},...
            'Style','edit',...
            'String',num2str(filter_settings.(filter_settings_names{idx_param}).val),...
            'HorizontalAlignment','center',...
            'Units',panel_unit,...
            'Visible',visibility,...
            'Position', [220  panel_first_line_pos-idx_param*panel_line_space 50 20]);
    else
        handles.Recon_Algo_Settings_h(idx_param).h(2) = uicontrol(...
            handles.uipanel_Recon_Algo_Settings,...
            'Callback',{@set_Recon_Algo_Settings_value, filter_settings_names(idx_param), 1, filter_settings.(filter_settings_names{idx_param}).type},...
            'Style','edit',...
            'String',num2str(filter_settings.(filter_settings_names{idx_param}).val(1)),...
            'HorizontalAlignment','center',...
            'Units',panel_unit,...
            'Visible',visibility,...
            'Position', [160  panel_first_line_pos-idx_param*panel_line_space 50 20]);
        handles.Recon_Algo_Settings_h(idx_param).h(3) = uicontrol(...
            handles.uipanel_Recon_Algo_Settings,...
            'Callback',{@set_Recon_Algo_Settings_value, filter_settings_names(idx_param), 2, filter_settings.(filter_settings_names{idx_param}).type},...
            'Style','edit',...
            'String',num2str(filter_settings.(filter_settings_names{idx_param}).val(end)),...
            'HorizontalAlignment','center',...
            'Units',panel_unit,...
            'Visible',visibility,...
            'Position', [220  panel_first_line_pos-idx_param*panel_line_space 50 20]);
    end
end

if num_of_params<=panel_max_lines
    set(handles.uipanel_Recon_Algo_Settings_slider,...
        'Visible','off');
else
    set(handles.uipanel_Recon_Algo_Settings_slider,...
        'Visible','on',...
        'Min',0,'Max',(num_of_params-panel_max_lines),...
        'Value',(num_of_params-panel_max_lines),...
        'Callback',{@uipanel_Recon_Algo_Settings_slider_callback,...
        handles, panel_first_line_pos, panel_max_lines, panel_line_space},...
        'SliderStep',[1 1]./(num_of_params-panel_max_lines));
end

% update selection button
set(handles.popupmenu_Recon_Algo_Select,'Value',...
    find(strcmp(handles.algo_names_and_handles_recon.names,handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_name)==1)...
    );

guidata(hObject, handles);


function uipanel_Recon_Algo_Settings_slider_callback(hObject, eventdata, handles, panel_first_line_pos, panel_max_lines, panel_line_space)

val = get(hObject,'Value');

num_of_params = length(handles.Recon_Algo_Settings_h);
for idx_setting = 1:num_of_params
    for idx_component = 1:length(handles.Recon_Algo_Settings_h(idx_setting).h)
        h = handles.Recon_Algo_Settings_h(idx_setting).h(idx_component);
        pos = get(h,'Position');
        pos_new = panel_first_line_pos - idx_setting * panel_line_space + (num_of_params-panel_max_lines - val) * panel_line_space;
        pos(2) = pos_new;
        if (pos_new < panel_first_line_pos - panel_max_lines * panel_line_space) || (pos_new > panel_first_line_pos - panel_line_space)
            visibility='off';
        else
            visibility='on';
        end
        set(h,...
            'Position',pos,...
            'Visible',visibility);
    end
end

guidata(hObject, handles);


function set_Recon_Algo_Settings_value(hObject, eventdata, param_name, idx, type)

handles = guidata(gcbo);
switch type
    case 'number'
        data_to_write = str2num(get(hObject,'String'));
    case 'text'
        data_to_write = get(hObject,'String');
    otherwise
        data_to_write = get(hObject,'String');
end

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.recon_algo_settings.(param_name{1}).val(idx)...
    = data_to_write;

guidata(hObject, handles);
setup_Recon_Algo_Settings_Panel(handles.figure1, eventdata, handles);



function selected_filter = get_selected_Filter(hObject, eventdata, handles)

if ~isfield(handles,'Channel_Settings_Radiobutton_h')
    selected_filter=0;
    return
end
for selected_filter=1:length(handles.Filter_Select_Radiobutton_h)
    if get(handles.Filter_Select_Radiobutton_h(selected_filter),'Value')==1
        break
    end
end
guidata(hObject, handles);

function selected_recon = get_selected_Recon(hObject, eventdata, handles)

if ~isfield(handles,'Channel_Settings_Radiobutton_h')
    selected_recon=0;
    return
end
for selected_recon=1:length(handles.Recon_Select_Radiobutton_h)
    if get(handles.Recon_Select_Radiobutton_h(selected_recon),'Value')==1
        break
    end
end
guidata(hObject, handles);


function selected_channel = get_selected_channel(hObject, eventdata, handles)

if ~isfield(handles,'Channel_Settings_Radiobutton_h')
    selected_channel=0;
    return
end
for selected_channel=1:length(handles.Channel_Settings_Radiobutton_h)
    if get(handles.Channel_Settings_Radiobutton_h(selected_channel),'Value')==1
        break
    end
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function uipanel_Select_Recon_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel_Select_Recon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% disp('uipanel_Select_Recon_CreateFcn')
handles.uipanel_Select_Recon_Slider = uicontrol('Style','Slider','Parent',hObject,...
    'Units','normalized','Position',[0.95 0 0.05 1],...
    'Visible','off',...
    'BackgroundColor',[0.8 0.8 0.8],...
    'Value',1);

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function uipanel_Filter_Settings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel_Filter_Settings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% disp(['uipanel_Filter_Settings_CreateFcn'])
handles.uipanel_Filter_Settings_slider = uicontrol('Style','Slider','Parent',hObject,...
    'Units','normalized','Position',[0.95 0 0.05 1],...
    'Visible','off',...
    'BackgroundColor',[0.8 0.8 0.8],...
    'Value',1);

guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function uipanel_Select_Filter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel_Select_Filter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% disp('uipanel_Select_Filter_CreateFcn')
handles.uipanel_Select_Filter_Slider = uicontrol('Style','Slider','Parent',hObject,...
    'Units','normalized','Position',[0.95 0 0.05 1],...
    'Visible','off',...
    'BackgroundColor',[0.8 0.8 0.8],...
    'Value',1);

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function uipanel_Recon_Algo_Settings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel_Recon_Algo_Settings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% disp('uipanel_Algo_Settings_CreateFcn')
handles.uipanel_Recon_Algo_Settings_slider = uicontrol('Style','Slider','Parent',hObject,...
    'Units','normalized','Position',[0.95 0 0.05 1],...
    'Visible','off',...
    'BackgroundColor',[0.8 0.8 0.8],...
    'Value',1);

guidata(hObject, handles);


function rearrange_radiobuttons_Recon(hObject, eventdata, handles)

num_of_recons=length(handles.Recon_Select_Radiobutton_h);
panel_pos = get(handles.uipanel_Select_Recon,'Position');
panel_unit = get(handles.uipanel_Select_Recon,'Unit');
for idx_radiobutton=1:num_of_recons
    if idx_radiobutton <= 7
        visibility = 'on';
    else
        visibility = 'off';
    end
    position = get(handles.Recon_Select_Radiobutton_h(idx_radiobutton),'Position');
    position(2) = panel_pos(4)-15-idx_radiobutton*30;
    set(handles.Recon_Select_Radiobutton_h(idx_radiobutton),...
        'Position',position,...
        'Visible',visibility);
end

if num_of_recons<7
    set(handles.uipanel_Select_Recon_Slider,'Visible','off');
end

guidata(hObject, handles);


function rearrange_radiobuttons_Filters(hObject, eventdata, handles)

num_of_filters=length(handles.Filter_Select_Radiobutton_h);
panel_pos = get(handles.uipanel_Select_Filter,'Position');
panel_unit = get(handles.uipanel_Select_Filter,'Unit');
for idx_radiobutton=1:num_of_filters
    if idx_radiobutton <= 7
        visibility = 'on';
    else
        visibility = 'off';
    end
    position = get(handles.Filter_Select_Radiobutton_h(idx_radiobutton),'Position');
    position(2) = panel_pos(4)-15-idx_radiobutton*30;
    set(handles.Filter_Select_Radiobutton_h(idx_radiobutton),...
        'Position',position,...
        'Visible',visibility);
end
if num_of_filters <= 7
    set(handles.uipanel_Select_Filter_Slider,'Visible','off');
end

guidata(hObject, handles);

% --- Executes on button press in pushbutton_Export_to_base.
function pushbutton_Export_to_base_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Export_to_base (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

assignin('base','params_export_rev',handles.params);
assignin('base','handles_export_rev',handles);

guidata(hObject, handles);


% --- Executes on button press in pushbutton_Process_All_Recons.
function pushbutton_Process_All_Recons_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Process_All_Recons (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.params = rainSTORM_image_reviewer_caller(handles.params);
guidata(hObject, handles);


% --- Executes on button press in pushbutton_Process_Current_Recon.
function pushbutton_Process_Current_Recon_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Process_Current_Recon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

SupResParams = handles.params.ch_data{selected_channel}.localization.results.SupResParams;
settings = handles.params.ch_data{selected_channel}.reviewer{selected_recon}.settings;

handles.params.ch_data{selected_channel}.reviewer{selected_recon}.results = ...
    rainSTORM_image_reviewer(SupResParams,settings);

guidata(hObject, handles);


% --- Executes on button press in pushbutton_Show_SupRes_Image.
function pushbutton_Show_SupRes_Image_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Show_SupRes_Image (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

pushbutton_Process_Current_Recon_Callback(hObject, eventdata, handles);
handles = guidata(gcbo);

text_figure_name = ['SupResImage of Ch ',num2str(selected_channel),': ',handles.params.ch_data{selected_channel, 1}.channel_name,...
    ', ',handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.recon_name];
handles.figLastReconHandle = rainSTORM_display(...
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.SupResIm,...                  % Image to reconstruct
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.reconstructionScaleFactor,... % reconstructionScaleFactor
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings,...                          % Flags to pass
    text_figure_name);

% if (handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings.flagDebug)
%     rejSupCo = handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.rejSupCo;
%     hold on 
%     plot(rejSupCo.y_coord,rejSupCo.x_coord, 'd','LineWidth',1,'Color','blue');
%     hold off
% end

guidata(hObject,handles);


% --- Executes on button press in pushbutton_Adjust_Contrast.
function pushbutton_Adjust_Contrast_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Adjust_Contrast (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Open imcontrast for figure.
h = imgcf;
imcontrast(h);


% --- Executes on selection change in popupmenu_Colormap_Select.
function popupmenu_Colormap_Select_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_Colormap_Select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_Colormap_Select contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_Colormap_Select


% --- Executes during object creation, after setting all properties.
function popupmenu_Colormap_Select_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_Colormap_Select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_Update_Color.
function pushbutton_Update_Color_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Update_Color (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Check desired colormap and set colors vector as needed.
str = get(handles.popupmenu_Colormap_Select, 'String');
val = get(handles.popupmenu_Colormap_Select, 'Value');
% Set current data to the selected data set.
switch str{val};
    case 'Green'
        color = [0   1   0];    % Green
        
    case 'Red'
        color = [1   0   0];    % Red
        
    case 'Blue'
        color = [0   0   1];    % Blue
        
    case 'Yellow'
        color = [1   1   0];    % Yellow
        
    case 'Cyan'
        color = [0   1   1];    % Cyan
        
    case 'Magenta'
        color = [1   0   1];    % Magenta
        
    case 'Grey'
        color = [];             % Grey
        
    case '<Colourmap>'
        % Sets colors to use default 'hot' colormap.
        color = [1   0   0;     % Red
            1   1   0];    % Yellow
end

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings.colormap = ...
    rainSTORM_colormap(color);
guidata(hObject,handles);


% --- Executes on button press in pushbutton_View_Histograms.
function pushbutton_View_Histograms_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_View_Histograms (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% update the according to the changes made
pushbutton_Process_Current_Recon_Callback(hObject, eventdata, handles);
handles = guidata(gcbo);

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

text_figure_name = ['Histograms of Ch ',num2str(selected_channel),': ',handles.params.ch_data{selected_channel, 1}.channel_name,...
    ', ',handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.recon_name];

rainSTORM_histograms(...
    handles.params.ch_data{selected_channel, 1},...
    selected_recon,...
    text_figure_name);

guidata(hObject,handles);


% --- Executes on button press in pushbutton_Box_Tracking.
function pushbutton_Box_Tracking_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Box_Tracking (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

if isfield(handles,'figLastReconHandle') && ishandle(handles.figLastReconHandle)
    figLastReconHandle = handles.figLastReconHandle;
else
    figLastReconHandle = rainSTORM_display(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.SupResIm,...    % SupResIm
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.reconstructionScaleFactor,...                      % linMag
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings,...                                               % flags to pass
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.recon_name);                                               % varargin
end
try
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings.box_track =...
        rainSTORM_boxTracker(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1},...
        figLastReconHandle);
catch myError
    warning('rainSTORM:boxFail','Box Tracker function failed: Run Reviewer, box, wait');
    handles.params.error = [handles.params.error ;myError];
end
guidata(hObject, handles);


% --- Executes on button press in pushbutton_Set_Anchor.
function pushbutton_Set_Anchor_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Set_Anchor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

if isfield(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings,'box_track')
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings.undrift = ...
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings.box_track;
end
handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings.undrift.markerAnchor =...
    rainSTORM_setAnchor(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1});

set(handles.pushbutton_Set_Anchor,'Enable','off');
guidata(hObject,handles);


% --- Executes on button press in pushbutton_Filter_Boxed.
function pushbutton_Filter_Boxed_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Filter_Boxed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);


filter_name = 'Box Tracking';
filter_params=struct(...
    'filter_name',filter_name,...
    'settings',rainSTORM_default_settings_loc_filters(filter_name));
filter_params.settings.x_coord.val = [handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.box_track.boxRows];
filter_params.settings.y_coord.val = [handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.box_track.boxCols];

handles.params.ch_data{selected_channel,1}.reviewer{selected_recon,1}.settings.filters{end+1,1} =...
    filter_params;

handles = setup_Select_Filter_Panel(hObject, eventdata, handles);
handles = setup_Filter_Settings_Panel(hObject, eventdata, handles);

guidata(hObject,handles);


% --- Executes on button press in pushbutton_Remove_Drift_Correction.
function pushbutton_Remove_Drift_Correction_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Remove_Drift_Correction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);
if isfield(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings,'undrift');
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings = ...
        rmfield(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings,'undrift');
end
if isfield(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings,'auto_undrift');
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings = ...
        rmfield(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1}.settings,'auto_undrift');
end
set(handles.pushbutton_Set_Anchor,'Enable','on');
guidata(hObject,handles);


% --- Executes on button press in pushbutton_Open_Calibration_Tool.
function pushbutton_Open_Calibration_Tool_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Open_Calibration_Tool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

rainSTORM_Calibration_Tool(handles.params);


% --- Executes on button press in pushbutton_Report_Current_Recon.
function pushbutton_Report_Current_Recon_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Report_Current_Recon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

rainSTORM_report(handles.params.ch_data{selected_channel,1},selected_recon);

rainSTORM_save_fullcsv(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon, 1}.results.reviewedSupResParams,...
    handles.params.ch_data{selected_channel, 1}.rawdata_mgr.fullfilename, 1);


% --- Executes on button press in pushbutton_Report_All_Recons.
function pushbutton_Report_All_Recons_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Report_All_Recons (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

rainSTORM_report_caller(handles.params);



% --- Executes on button press in pushbutton_Open_Merge_Tool.
function pushbutton_Open_Merge_Tool_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Open_Merge_Tool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

rainSTORM_Merge_Tool(handles.params);


% --- Executes on button press in bridgeTracker.
function bridgeTracker_Callback(hObject, eventdata, handles)
% hObject    handle to bridgeTracker (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

if isfield(handles,'figLastReconHandle') && ishandle(handles.figLastReconHandle)
    figLastReconHandle = handles.figLastReconHandle;
else
    figLastReconHandle = rainSTORM_display(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.SupResIm,...    % SupResIm
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.reconstructionScaleFactor,...                      % linMag
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings,...                                               % flags to pass
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.recon_name);                                               % varargin

end
rainSTORM_bridgeTracker(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1},figLastReconHandle);

guidata(hObject, handles);



% --- Executes on button press in pushbutton_Save_Localization_Data.
function pushbutton_Save_Localization_Data_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Save_Localization_Data (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

if ~isempty(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon, 1}.results.reviewedSupResParams)
rainSTORM_save_fullcsv(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon, 1}.results.reviewedSupResParams,...
    handles.params.ch_data{selected_channel, 1}.rawdata_mgr.fullfilename, 1);
rainSTORM_save_csv(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon, 1}.results.reviewedSupResParams,...
    handles.params.ch_data{selected_channel, 1}.rawdata_mgr.fullfilename, 0);
else
    msgbox({'The reviewedSupResParams variable is empty!', 'Click "Show SupRes Image" first!'}, 'Nothing to save!' );
end

 


% --- Executes on button press in auto_drift_corr.
function auto_drift_corr_Callback(hObject, eventdata, handles)
% hObject    handle to auto_drift_corr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% get the available filter and reconstruction algo names and handles
selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

settings = handles.params.ch_data{selected_channel}.reviewer{selected_recon}.settings;
SupResParams = handles.params.ch_data{selected_channel}.localization.results.SupResParams;

% filter the localization data
algo_names_and_handles_loc_filter = rainSTORM_default_settings_loc_filters;
qualityApprovedLocs = true(size(SupResParams));
for idx_filter = 1:length(settings.filters)
    loc_filter_handle = algo_names_and_handles_loc_filter.fhandle{...
        (strcmp(algo_names_and_handles_loc_filter.names,settings.filters{idx_filter}.filter_name)==1)};
    [accepted_localizations, filterOutputHists] = loc_filter_handle(SupResParams,settings.filters{idx_filter}.settings,settings.flagDebug);
    qualityApprovedLocs = qualityApprovedLocs & accepted_localizations;
end
reviewedSupResParams = SupResParams(qualityApprovedLocs);

handles.params.ch_data{selected_channel}.reviewer{selected_recon}.settings.auto_undrift =...
    rainSTORM_undrift_auto(reviewedSupResParams);

guidata(hObject, handles);


% --- Executes on button press in BaSDI_drift_corr.
function BaSDI_drift_corr_Callback(hObject, eventdata, handles)
% hObject    handle to BaSDI_drift_corr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% get the available filter and reconstruction algo names and handles
selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

settings = handles.params.ch_data{selected_channel}.reviewer{selected_recon}.settings;
SupResParams = handles.params.ch_data{selected_channel}.localization.results.SupResParams;

% filter the localization data
algo_names_and_handles_loc_filter = rainSTORM_default_settings_loc_filters;
qualityApprovedLocs = true(size(SupResParams));
for idx_filter = 1:length(settings.filters)
    loc_filter_handle = algo_names_and_handles_loc_filter.fhandle{...
        (strcmp(algo_names_and_handles_loc_filter.names,settings.filters{idx_filter}.filter_name)==1)};
    [accepted_localizations, filterOutputHists] = loc_filter_handle(SupResParams,settings.filters{idx_filter}.settings,settings.flagDebug);
    qualityApprovedLocs = qualityApprovedLocs & accepted_localizations;
end
reviewedSupResParams = SupResParams(qualityApprovedLocs);

handles.params.ch_data{selected_channel}.reviewer{selected_recon}.settings.auto_undrift =...
    rainSTORM_undrift_BaSDI(reviewedSupResParams);

guidata(hObject, handles);


% --- Executes on button press in pushShowrejSupIm.
function pushShowrejSupIm_Callback(hObject, eventdata, handles)
% hObject    handle to pushShowrejSupIm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

% pushbutton_Process_Current_Recon_Callback(hObject, eventdata, handles);
handles = guidata(gcbo);

text_figure_name = ['rejResImage of Ch ',num2str(selected_channel),': ',handles.params.ch_data{selected_channel, 1}.channel_name,...
    ', ',handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.recon_name];
handles.figLastReconHandle = rainSTORM_display(...
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.rejSupIm,...                  % Image to reconstruct
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.reconstructionScaleFactor,... % reconstructionScaleFactor
    handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings,...                          % Flags to pass
    text_figure_name);

guidata(hObject,handles);


% --- Executes on button press in pushbutton42.
%flip falgDebug
function pushbutton42_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton42 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

% pushbutton_Process_Current_Recon_Callback(hObject, eventdata, handles);
handles = guidata(gcbo);

handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings.flagDebug...
    = ~(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings.flagDebug);

if ~(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings.flagDebug)
    set(handles.pushShowrejSupIm,'Visible','off');
else
    set(handles.pushShowrejSupIm,'Visible','on');
end

guidata(hObject,handles);


% --- Executes on button press in histtracker.
function histtracker_Callback(hObject, eventdata, handles)
% hObject    handle to histtracker (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
selected_recon = get_selected_Recon(hObject, eventdata, handles);

if isfield(handles,'figLastReconHandle') && ishandle(handles.figLastReconHandle)
    figLastReconHandle = handles.figLastReconHandle;
else
    figLastReconHandle = rainSTORM_display(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.SupResIm,...    % SupResIm
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.results.reconstructionScaleFactor,...                      % linMag
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.settings,...                                               % flags to pass
        handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon}.recon_name);                                               % varargin

end
rainSTORM_histogramTracker(handles.params.ch_data{selected_channel, 1}.reviewer{selected_recon,1},figLastReconHandle);

guidata(hObject, handles);
