function [Image,others] = rainSTORM_reconAVP(SupResParams,settings)
% Copyright 2012. Refer to 00_license.txt for details.

linMag = settings.linMag.val;
sizeOfCCDFrame = settings.sizeOfCCDFrame.val;
SupResPosits = [...
    [SupResParams.x_coord]',...
    [SupResParams.y_coord]'...
    ];

nRows = sizeOfCCDFrame(1)*linMag;  % Size of super-resolution reconstruction
nCols = sizeOfCCDFrame(2)*linMag;
SupResImHist = uint16(zeros(nRows,nCols)); % 2^16 is unlikely to overflow

myPosits = SupResPosits*linMag; % Scale localisations to super-res grid
myPosits = ceil(myPosits);      % Digitise localisations to super-res grid

for lpSRI = 1:size(myPosits,1)
    SupResImHist( myPosits(lpSRI,1)  , myPosits(lpSRI,2)  ) = ...
        SupResImHist( myPosits(lpSRI,1)  , myPosits(lpSRI,2)  ) +1;
    % Elementwise binning. Not very elegant, I admit.
end % End of allocating dyes to pixels of the reconstruction

SupResImPrec = uint16(zeros(nRows,nCols)); % 2^16 is unlikely to overflow
deltaX = [[SupResParams.x_std]', [SupResParams.y_std]'];

for lpSRI = 1:size(myPosits,1)
    SupResImPrec( myPosits(lpSRI,1)  , myPosits(lpSRI,2)  ) = ...
        SupResImPrec( myPosits(lpSRI,1)  , myPosits(lpSRI,2)  ) + deltaX(lpSRI,1);
    
end % End of allocating dyes to pixels of the reconstruction

% Divide sum of precisions by histogram image to produce a confidence
% image.
Image = (100*SupResImHist./SupResImPrec);

others.reconstructionScaleFactor = linMag;
others.sizeOfCCDFrame = sizeOfCCDFrame;
others.SupResImHist = SupResImHist;
others.SupResImPrec = SupResImPrec;
end


