function rainSTORM_save_csv( toreportSupResParams, locFileName, mode )
% Mode: 0->gui; 1->batch-reviewed; 2->batch-total
% The only change is in the name giving, as this function is used to export
% the localization-result-struct.
    
    [pathstr,name,ext] = fileparts( locFileName );
    if (mode == 1)
        filename = [name, '_reviewedSupResParams.csv'];
        PathName = pathstr;
    elseif (mode == 2)
        filename = [name, '_SupResParams.csv'];
        PathName = pathstr;
    else
        [filename, PathName] = uiputfile( [pathstr '/' name '_reviewedSupResParams.csv'] );
    end
    
    fp = fopen( [PathName '/' filename], 'w+t' );
    fprintf( fp, 'idx,frame_idx,x_coord,y_coord,x_std,y_std,I,sig_x,sig_y\n' );
    
    N = length(toreportSupResParams);
    hWaitBar = waitbar(0, 'Saving loc. data: 0%' );
    for i = 1:N
        if mod(i,1000) == 0
            perc = i / N;
            waitbar( perc, hWaitBar, sprintf('Saving loc. data: %d%%', round(perc*100) ) )
        end
        
        fprintf( fp, '%d,%d,%f,%f,%f,%f,%.2f,%f,%f\n', i, toreportSupResParams(i).frame_idx, ...
            toreportSupResParams(i).x_coord, toreportSupResParams(i).y_coord, ...
            toreportSupResParams(i).x_std, toreportSupResParams(i).y_std, ...
            toreportSupResParams(i).I, ...
            toreportSupResParams(i).sig_x, toreportSupResParams(i).sig_y );
    end
    fclose( fp );
    close( hWaitBar );

end

