function generate_test_cases_4(seq_path)
% Sample parameter settings
seq_params=[];

% Storage info
seq_params.filename='Offset_test';
seq_params.format='tif';
seq_params.path=seq_path;

% Dye parameter settings
seq_params.dye.name='base_dye';
seq_params.dye.tauon=0.05;
seq_params.dye.tauoff=25;
seq_params.dye.taub=500;
seq_params.dye.lambda=647;
seq_params.dye.N_ofphotonpersec=400000;

% Acqusition / Camera settings
seq_params.aq.frame_size=128;% The frame size NxN.
seq_params.aq.frame_N_max=100;% The number of frames in sequence fragment.
seq_params.aq.frame_N=seq_params.aq.frame_N_max;
seq_params.aq.frame_rate=100;% frame/s
seq_params.aq.frame_fill_factor=1;% the fraction of the exposure time used to collect photons.
seq_params.aq.pixel_size=160;
seq_params.aq.bg_level=10;
seq_params.psf.name='gauss';
seq_params.psf.size=120;
seq_params.psf.n=1.33;

% Variable parameter setting
mol_pos_N=8;
mol_pos_orig=[m_gen_descartes_prod([mol_pos_N,mol_pos_N])'*128/mol_pos_N-128/mol_pos_N/2;zeros(1,mol_pos_N^2)]*seq_params.aq.pixel_size;%nm

param_infos=[];
param_infos(1).N_photons=4000;% The number of photons per frame.
param_infos(1).sig_per_pix=1;%
param_infos(1).mol_pos=mol_pos_orig;%nm
param_infos(1).mol_N=length(param_infos(1).mol_pos(1,:));%
param_infos(1).traj_delay=0.*ones(1,param_infos(1).mol_N);%
param_infos(1).traj_length=100*ones(1,param_infos(1).mol_N);%
param_infos(1).traj_frames=100;%

opt_axis_vec=[60;80;0]*seq_params.aq.pixel_size;%nm;x,y,z
param_infos(2)=param_infos(1);
param_infos(2).mol_pos=repmat(opt_axis_vec,1,size(mol_pos_orig,2))+1.01*(mol_pos_orig-repmat(opt_axis_vec,1,size(mol_pos_orig,2)));
param_infos(2).mol_N=length(param_infos(2).mol_pos(1,:));%
param_infos(2).traj_delay=0.*ones(1,param_infos(2).mol_N);%
param_infos(2).traj_length=100*ones(1,param_infos(2).mol_N);%
param_infos(2).traj_frames=100;%


%%
if ~isdir(seq_params.path)
    mkdir(seq_params.path)
end
save([seq_params.path,filesep,seq_params.filename,'_param_infos.mat'],'param_infos','seq_params')

%%

generate_test_cases_write_seq(seq_params,param_infos);


end



