function generate_test_cases_write_seq(seq_params,param_infos)

traj_frame_idx=cumsum([param_infos.traj_frames]);
total_frame_num=traj_frame_idx(end);
seq_N=ceil(total_frame_num/seq_params.aq.frame_N_max);

seq_traj_idx=zeros(1,seq_N);
treshold=seq_params.aq.frame_N_max;
for idx_seq=1:seq_N
    seq_traj_idx(idx_seq)=find(traj_frame_idx<=treshold,1,'last');
    treshold=traj_frame_idx(seq_traj_idx(idx_seq))+seq_params.aq.frame_N_max;
end

traj_begin=1;
frame_begin=1;
for idx_seq=1:seq_N
    tic
    trajs=traj_gen(seq_params,param_infos(traj_begin:seq_traj_idx(idx_seq)));
    toc
    seq_params.aq.frame_N=traj_frame_idx(seq_traj_idx(idx_seq))-frame_begin+1;
    seq=m_gen_trajs_to_seq(...
        trajs,...
        seq_params.aq,...
        seq_params.psf,...
        seq_params.dye);
    toc
    seq_n=m_gen_noise_addition(...
        seq,...
        seq_params.aq);
    toc
    m_gen_seq_save(seq_n,[seq_params.path,filesep,seq_params.filename,num2str(idx_seq,'%2.2i'),'.',seq_params.format]);
    toc
    traj_begin=seq_traj_idx(idx_seq)+1;
    frame_begin=traj_frame_idx(seq_traj_idx(idx_seq))+1;
end
end


function output=traj_gen(seq_params,param_infos)

traj_frame_idx=[0 cumsum([param_infos.traj_frames])];
t_max=seq_params.aq.frame_rate*traj_frame_idx(end);

trajs_out=[];
for idx_traj=1:length(param_infos)
    clear trajs
    trajs(1:param_infos(idx_traj).mol_N)=struct(...
        'bleach',0,...
        'Nofactive',0,...
        't',0,...
        'pos',zeros(3,1)...
        );
    for idx_mol=1:param_infos(idx_traj).mol_N
        state_value=param_infos(idx_traj).N_photons*seq_params.aq.frame_rate;
        trajs(idx_mol).state=[0 state_value 0];
        trajs(idx_mol).t=[0 traj_frame_idx(idx_traj)+param_infos(idx_traj).traj_delay(idx_mol)...
            traj_frame_idx(idx_traj)+param_infos(idx_traj).traj_delay(idx_mol)+param_infos(idx_traj).traj_length(idx_mol)...
            ]/seq_params.aq.frame_rate;
        trajs(idx_mol).pos=repmat(...
            param_infos(idx_traj).mol_pos(:,idx_mol),1,length(trajs(idx_mol).state));
        trajs(idx_mol).Nofactive=sum(trajs(idx_mol).state>0);
    end
    trajs_out=[trajs_out,trajs];
end
output.t_max=t_max;
output.ts=trajs_out;

end
