function output=rainSTORM_batch_mode(params,loc_undrift)


%%%%%%%%%%%%%%%%%%%%%%%%
% Do the localizations
for selected_channel = 1:length(params.ch_data)
    params.ch_data{selected_channel,1} = rainSTORM_main(params.ch_data{selected_channel,1});
end

%%
% Do auto drift correction if requested
switch loc_undrift
    case 0
        % Do nothing
    case 1
        % NemethJ drift correction
        settings = params.ch_data{1, 1}.reviewer{1, 1}.settings;
        % settings.flagDebug is not used here on purpose.
        SupResParams = params.ch_data{1, 1}.localization.results.SupResParams;

        % filter the localization data
        algo_names_and_handles_loc_filter = rainSTORM_default_settings_loc_filters;
        qualityApprovedLocs = true(size(SupResParams));
        for idx_filter = 1:length(settings.filters)
            loc_filter_handle = algo_names_and_handles_loc_filter.fhandle{...
                (strcmp(algo_names_and_handles_loc_filter.names,settings.filters{idx_filter}.filter_name)==1)};
            [accepted_localizations, filterOutputHists] = loc_filter_handle(SupResParams,settings.filters{idx_filter}.settings,'false');
            qualityApprovedLocs = qualityApprovedLocs & accepted_localizations;
        end
        reviewedSupResParams = SupResParams(qualityApprovedLocs);

        params.ch_data{1, 1}.reviewer{1, 1}.settings.auto_undrift =...
                rainSTORM_undrift_auto(reviewedSupResParams);
    case 2
        % BaSDI drift correction
        settings = params.ch_data{1, 1}.reviewer{1, 1}.settings;
        SupResParams = params.ch_data{1, 1}.localization.results.SupResParams;

        % filter the localization data
        algo_names_and_handles_loc_filter = rainSTORM_default_settings_loc_filters;
        qualityApprovedLocs = true(size(SupResParams));
        for idx_filter = 1:length(settings.filters)
            loc_filter_handle = algo_names_and_handles_loc_filter.fhandle{...
                (strcmp(algo_names_and_handles_loc_filter.names,settings.filters{idx_filter}.filter_name)==1)};
            [accepted_localizations, filterOutputHists] = loc_filter_handle(SupResParams,settings.filters{idx_filter}.settings,'false');
            qualityApprovedLocs = qualityApprovedLocs & accepted_localizations;
        end
        reviewedSupResParams = SupResParams(qualityApprovedLocs);

        params.ch_data{1, 1}.reviewer{1, 1}.settings.auto_undrift =...
                rainSTORM_undrift_BaSDI(reviewedSupResParams);
end

%%
% Generate super resolved images
params = rainSTORM_image_reviewer_caller(params);

%%
% Generate reports
rainSTORM_report_caller(params);

%%

if (params.ch_data{1, 1}.reviewer{1,1}.settings.flagDebug)
    % Save All in csv
    rainSTORM_save_fullcsv(params.ch_data{1, 1}.localization.results.SupResParams,...
        params.ch_data{1, 1}.rawdata_mgr.fullfilename, 2);

    % Save Locs in csv
    rainSTORM_save_fullcsv(params.ch_data{1, 1}.reviewer{1, 1}.results.reviewedSupResParams,...
        params.ch_data{1, 1}.rawdata_mgr.fullfilename, 1);
else
    % Save All in csv
    rainSTORM_save_csv(params.ch_data{1, 1}.localization.results.SupResParams,...
        params.ch_data{1, 1}.rawdata_mgr.fullfilename, 2);

    % Save Locs in csv
    rainSTORM_save_csv(params.ch_data{1, 1}.reviewer{1, 1}.results.reviewedSupResParams,...
        params.ch_data{1, 1}.rawdata_mgr.fullfilename, 1);
end

%%
% Close all the generated figures if any.
close all
output = params;