function rainSTORM_batch_mode_call(PathName,file_filter,readmethod,loc_undrift)
% usage: rainSTORM_batch_mode_call('images\','.tif','tiff',[0-2])
% Undrift Options:  0-> none
%                   1-> NemethJ undrift >> rainSTORM_undrift_auto()
%                   2-> BaSDI undrift   >> rainSTORM_undrift_BaSDI()

if nargin==1
    file_filter='*.tif';
    readmethod='tiff';
end
listOfFiles = dir([PathName,'*',file_filter]);

for idx_file=1:length(listOfFiles)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Create Params Struct
    params = rainSTORM_default_struct_params;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Enable filter debugging
    params.ch_data{1, 1}.reviewer{1, 1}.settings.flagDebug = true;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Set the file info
    params.ch_data{1, 1}.rawdata_mgr.fullfilename=[PathName,filesep,listOfFiles(idx_file).name];
    params.ch_data{1, 1}.rawdata_mgr.readmethod=readmethod;
    
    % run rainSTORM and save the results
    params=rainSTORM_batch_mode(params,loc_undrift);
    
%    [pathstr, name, ext] = fileparts(params.ch_data{1, 1}.rawdata_mgr.fullfilename);
%    filename = fullfile(pathstr,name);
%    save([filename,'_rainSTORM.mat'],'params')
% Save to mat disabled
end